apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ memcached_name }}
  name: {{ memcached_name }}
  namespace: {{ namespace }}
spec:
  podManagementPolicy: Parallel
  replicas: {{ memcached_replicas }}
  selector:
    matchLabels:
      name: {{ memcached_name }}
  serviceName: {{ memcached_name }}
  template:
    metadata:
      labels:
        name: {{ memcached_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities | default(True) %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ memcached_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ memcached_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - args:
        - memcached
        - -m
        - "{{ memory_limit_mbyte | default(64) }}"
        image: {{ (opsimages | json_query("[?name=='memcached'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 20
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 15
          periodSeconds: 20
          tcpSocket:
            port: 11211
          timeoutSeconds: 2
        name: memcached
        ports:
        - containerPort: 11211
          name: memcached
        readinessProbe:
          initialDelaySeconds: 15
          periodSeconds: 10
          tcpSocket:
            port: 11211
        resources:
          limits:
            cpu: "{{ cpu_limit }}"
            memory: "{{ memory_limit }}"
          requests:
{% if ensure_dbs_has_guaranteed_qosclass | default(True) %}
            cpu: "{{ cpu_limit }}"
            memory: "{{ memory_limit }}"
{% else %}
            cpu: "{{ cpu_request }}"
            memory: "{{ memory_request }}"
{% endif %}
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 20
          initialDelaySeconds: 15
          periodSeconds: 20
          tcpSocket:
            port: 11211
          timeoutSeconds: 2
{% endif %}
{% if do_exporters %}
      - args:
        - --memcached.address=127.0.0.1:11211
        - --web.listen-address=:9113
        image: {{ (opsimages | json_query("[?name=='memcachedexporter'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 9113
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
{% if ensure_dbs_has_guaranteed_qosclass | default(True) %}
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
{% else %}
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
{% endif %}
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-cache
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
      securityContext:
        runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ memcached_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
